use tonic::transport;

use lws_vfs::LwsVfsIns;
use lws_vfs::lws_vfs::lws_vfs_server::LwsVfsServer;
extern crate log;
// fn main() {
//     println!("Hello, world!");
//     let file = "test.txt";
//     let mut sta = Stat {
//         st_size: 0,
//         st_mode: 0,
//     };
//     let mut fi = FuseFileInfo {};
//     getattr(file, &mut sta, &mut fi);
// }

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    env_logger::init();
    let instance = match LwsVfsIns::new("config.json"){
        Ok(greeter) => greeter,
        Err(e) => {
            log::error!("Error creating lws server instance: {:?}", e);
            return Err(e);
        }
    };
    let addr = format!("0.0.0.0:{}", instance.config.get_port());
    log::info!("Listening on {}", addr);
    transport::Server::builder()
        .add_service(LwsVfsServer::new(instance))
        .serve(addr.parse()?)
        .await?;
    Ok(())
}
